from rest_framework import serializers

from suitablephones.models import Bluetooth, Camera, Device


class CameraSerializer(serializers.ModelSerializer):
    class Meta:
        model = Camera
        exclude = ["id"]


class BluetoothSerializer(serializers.ModelSerializer):
    class Meta:
        model = Bluetooth
        exclude = []



class DeviceSerializer(serializers.ModelSerializer):
    bluetooth = BluetoothSerializer(many=False, read_only=True)
    cameras = CameraSerializer(many=True, read_only=True)

    class Meta:
        model = Device
        exclude = ["id"]